   PROGRAM

 INCLUDE('pjsip.inc')

   MAP
     SIPOnRegState(long l1, long l2),long,C
     SIPOnCallState(long l1, long l2),long,C
     SIPOnCallIncoming(long l1, long uri2),long,C
   END

sip    sipclass
SIPURI CSTRING(256)

account              LONG                                  !
number               CSTRING(20)                           !
port                 LONG(5060)                            !
Host                 STRING(80)                            !
Username             STRING(80)                            !
Pass                 STRING(80)                            !
regstate             LONG                                  !
callstate            STRING(20)                            !
Caller               STRING(80)                            !
callid               LONG                                  !
CQ                   QUEUE(SIPCodecsQ),PRE()               !
                     END                                   !
Codec                STRING(20)                            !

Window               WINDOW('SIP'),AT(,,312,107),FONT('MS Sans Serif',8,,FONT:regular),TIMER(100),SYSTEM,GRAY,DOUBLE
                       GROUP(' <255>'),AT(4,6,132,81),USE(?Group1),BOXED
                         STRING(':'),AT(10,19),USE(?String3)
                         ENTRY(@s80),AT(47,17,81,12),USE(Host),FLAT
                         STRING(':'),AT(10,35),USE(?String4)
                         ENTRY(@s80),AT(47,34,81,12),USE(Username),FLAT
                         ENTRY(@s80),AT(47,50,81,12),USE(Pass),FLAT
                         STRING(@n-14),AT(11,68,35,10),USE(regstate)
                         BUTTON(''),AT(67,66,61,14),USE(?OkButton),LEFT,DEFAULT
                         STRING(':'),AT(10,52),USE(?String6)
                       END
                       BUTTON(''),AT(257,66,51,14),USE(?Button4)
                       BUTTON(' '),AT(208,90,100,14),USE(?Button5)
                       STRING(@s20),AT(5,93,66,10),USE(callstate)
                       STRING(@s20),AT(119,93),USE(Codec)
                       STRING(':'),AT(143,19),USE(?String5)
                       ENTRY(@s19),AT(172,17,81,12),USE(number),FLAT
                       BUTTON(''),AT(257,16,51,14),USE(?Button3)
                       STRING('<255> '),AT(143,36),USE(?String10),HIDE,FONT(,20,,)
                       STRING(@s80),AT(144,65,98,16),USE(Caller),FONT(,14,,)
                     END

 CODE

    Sip.SipConfig.LogLevel=0
    Sip.Init(address(SIPOnRegState),address(SIPOnCallState),address(SIPOnCallIncoming))
    Sip.FillCodecs(CQ)

    Open(Window)

    settarget(window)
    accept
      case event()
      of Event:Accepted
        case Field()
        OF ?OkButton
          Account=Sip.Login(Host,Port,Username,Pass)
        OF ?Button4
           SIP.Answer()
        OF ?Button5
           SIP.Release()
        OF ?Button3
           SIP.makeCall(Number)
        end
      of event:timeR
        RegState=Sip.Regstate
        if SIP.Incoming=1
          Sip.GetCaller(SIPuri)
          beep(BEEP:SystemExclamation)
        end
        Caller=Sip.Caller
        CallState=Sip.GetCallState()
        Codec=Sip.GetCurrentCodec()
        ?String10{prop:hide}=choose(SIP.Incoming=1,0,1)
        display
      end
    end
    SIP.Kill()
    close(window)

SIPOnRegState  procedure(LONG l1, LONG l2)
 code
 Sip.regstate=l2
 return 0

SIPOnCallState  procedure(LONG l1, LONG l2)
 code
 SIP.CallID=l1
 SIP.CallState=l2
 SIP.Incoming=0
 return 0

SIPOnCallIncoming  procedure(LONG l1, long uri2)
slen long
 code
 SIP.Incoming=1
 SIP.CallID=l1
 slen = strlen(uri2)
 SIP_memcpy(address(SIPUri), uri2, slen)
 return 0